<?php

    /**
     * @author Dima_tomsk
     * @version 0.2
     */


    /**
     * try to start session, if session alredy start - skip it
     */
    @session_start();

    define( 'IMG_LINE' ,   1 );
    define( 'IMG_CIRCLE' , 2 );
    define( 'IMG_SQUARE' , 4 );
    define( 'IMG_DOT' ,    8 );

    // {{{
    function isPostedCodeTrue( $name_code )
    {
        if ( isset( $_POST[ $name_code ] ) ) {
            return ( $_POST[ $name_code ] == $_SESSION[ 'code_hidden_field' ] );
        } // if
        return false;
    }
    // }}}

    // {{{ C_Image
    class C_Image
    {
        var $_img;
        var $_width;
        var $_height;
        var $_count;
        var $_use_alphanumeric;
        var $_rotate_angle;
        var $_fontsize;
        var $_type;

        // {{{ C_Image
        function C_Image( $param )
        {
            $this->_img = null;
            /**
             * user params
             */
            $this->_width    = $this->_is_exists( $param, 'width',  88 );
            $this->_height   = $this->_is_exists( $param, 'height', 31 );
            $this->_count    = $this->_is_exists( $param, 'count',  4  );
            $this->_use_alphanumeric =
                               $this->_is_exists( $param, 'alphanumeric', true );
            $this->_rotate_angle =
                               $this->_is_exists( $param, 'rotate',  0 );
            $this->_type     = $this->_is_exists( $param, 'type', IMG_LINE | IMG_DOT );
            $this->_fontsize = 5;
        }
        // }}} C_Image

        // {{{ free
        function free()
        {
            if ( $this->_img != null ) {
                imagedestroy( $this->_img );
                $this->_img = null;
            } // if
        }
        // }}}

        // {{{
        /**
         * help function
         */
        function _is_exists( $array, $name = null, $dafault = null )
        {
            if ( isset( $name ) and isset( $array[ $name ] ) ) {
                return $array[ $name ];
            }
            else {
                return $dafault;
            } // if
        }
        // }}}

        // {{{ _init
        function _init()
        {
            // create handle for image
            if ( function_exists('imagecreatetruecolor') ) {
                $this->_img = imagecreatetruecolor($this->_width, $this->_height);
            }
            else {
                $this->_img = imagecreate($this->_width, $this->_height);
            }
            // fill the background color
            $bg = imagecolorallocate($this->_img, 255, 255, 225);
            imagefill($this->_img, 5, 5, $bg);
        }
        // }}} _init

        // {{{ _drawLines
        function _drawLines( $n = 10 )
        {
            $color = imagecolorallocate($this->_img, 200, 200, 200);
            for ( $i = 0 ; $i < $n ; $i ++ ) {
                $x = intval( rand(0, $this->_width) );
                $y = intval( rand(0, $this->_height) );
                $w = intval( rand(0, $this->_width) );
                $h = intval( rand(0, $this->_height) );
                imageline($this->_img, $x, $y, $w, $h, $color);
            } // for
        }
        // }}} _drawLines

        // {{{ _drawDots
        function _drawDots( $n = 10 )
        {
            $color = imagecolorallocate($this->_img, 200, 200, 200);
            for ( $i = 0 ; $i < $n ; $i ++ ) {
                $x = intval( rand(0, $this->_width) );
                $y = intval( rand(0, $this->_height) );
                imagesetpixel($this->_img, $x, $y,   $color);
                imagesetpixel($this->_img, $x+1, $y, $color);
                imagesetpixel($this->_img, $x-1, $y, $color);
                imagesetpixel($this->_img, $x, $y+1, $color);
                imagesetpixel($this->_img, $x, $y-1, $color);
            } // for
        }
        // }}} _drawDots

        // {{{ _drawSquare
        function _drawSquare( $n = 10 )
        {
            $color = imagecolorallocate($this->_img, 200, 200, 200);
            for ( $i = 0 ; $i < $n ; $i ++ ) {
                $x = intval( rand(0, $this->_width) );
                $y = intval( rand(0, $this->_height) );
                $w = $x + 7;
                $h = $y + 7;
                imagefilledrectangle( $this->_img, $x, $y, $w, $h, $color );
            } // for
        }
        // }}} _drawSquare

        // {{{ _generateText( )
        function _generateText( )
        {
            $session_text = '';
            if ( $this->_use_alphanumeric ) {
                /**
                 *  use alpha and numeric
                 */
                for($i = 0; $i < $this->_count; $i++)
                {
                 		if ( $i & 1 == 1 ) {
                     		$char = round(rand(0, 9));
                 		}
                 		else {
                 		    if ( rand(0, 1) == 1 )
                     		    $char = chr ( round(rand(97, 122)) );
                     		else
                     		    $char = chr ( round(rand(65, 90)) );
                 		}
                  	$session_text .=  $char;
                } // for

            }
            else {
                /**
                 * use numeric only
                 */
                for($i = 0; $i < $this->_count; $i++)
                {
                 		$char = round(rand(0, 9));
                  	$session_text .=  $char;
                } // for
            } // if

       	    $this->_rotateImage( $session_text );

            $_SESSION[ 'code_hidden_field' ] = $session_text;
        }
        // }}} _generateText( )

        // {{{ _drawCircle
        function _drawCircle( $n = 10 )
        {
            $color = imagecolorallocate($this->_img, 200, 200, 200);
            for ( $i = 0 ; $i < $n ; $i ++ ) {
                $x = intval( rand(0, $this->_width) );
                $y = intval( rand(0, $this->_height) );
                $w = 20;
                $h = 10;
                imagefilledellipse($this->_img, $x, $y, $w, $h, $color);
            } // for
        }
        // }}} _drawCircle

        // {{{ _drawBorder
        function _drawBorder()
        {
            $color = imagecolorallocate($this->_img, rand(0,100), rand(0,100), rand(0,100));
            imagerectangle($this->_img, 0, 0, $this->_width - 1, $this->_height - 1, $color);
        }
        // }}} _drawBorder

        // {{{ _rotateImage
        function _rotateImage( $random_text = '1233' )
        {
            if ( function_exists('imagecreatetruecolor') ) {
                $func_name = 'imagecreatetruecolor';
            }
            else {
                $func_name = 'imagecreate';
            } // if

            $bg         = imagecolorallocate($this->_img, 255, 255, 225);
            $brdr_color = imagecolorallocate($this->_img, 0, 0, 0);

            $delta = intval($this->_width / $this->_count);

            for ( $i = 0 ; $i < $this->_count ; $i ++ ) {

                $tmp_im = $func_name($this->_width, $this->_height);

                imagefill($tmp_im, 5, 5, $bg);
                $color = imagecolorallocate($tmp_im, rand(0,100), rand(0,100), rand(0,100));

                imagestring($tmp_im,
                            rand(4, 6),      // font
                            $i * $delta,     // x
                            $i * rand(0, 5), // y
                            $random_text{ $i },
                            $color);

                $tmp_im = imagerotate($tmp_im, rand(5, 10) * (rand(0, 1) > 0.5 ? -2 : 2), $bg);

                ImageColorTransparent($tmp_im, $bg);

                imagecopymerge($this->_img, $tmp_im, 0, 0, 0, 0, $this->_width, $this->_height, 100);

                imagedestroy( $tmp_im );
            } // for
        }
        // }}} _rotateImage

        // {{{ _process
        function _process()
        {
            $this->_init();

            if ( $this->_type & IMG_LINE )
                $this->_drawLines(  5 );

            if ( $this->_type & IMG_SQUARE )
                $this->_drawSquare( 3 );

            if ( $this->_type & IMG_CIRCLE )
                $this->_drawCircle( 5 );

            if ( $this->_type & IMG_DOT )
                $this->_drawDots(  20 );

            $this->_generateText( );
            $this->_drawBorder();
        }
        // }}} _process

        // {{{ show
        function show()
        {
            $this->_process();

            header("Content-type: image/png");
            imagepng( $this->_img );

            $this->free();
        }
        // }}} show

    }
    // }}} end of C_Image
?>