<?php

    define( 'EOL', "\n" );

    // {{{
    class C_Simple_Menu
    {
        // {{{
        var $_array;
        var $_is_vertical;
        var $_itemIndex;
        // }}}

        // {{{ C_Simple_Menu( )
        function C_Simple_Menu( )
        {
            $this->_array       = array( );
            $this->_is_vertical = false;
            $this->_itemIndex   = 0;
        }
        // }}} C_Simple_Menu( )

        // {{{  param( )
        function param( $arr = null )
        {
            if ( ! is_array( $arr ) )
                return false;

            /**
             * add link to array
             */
            $this->_array = array_merge($this->_array, $arr);
        }
        // }}} param( )

        // {{{ setActiveIndex( )
        function setActiveIndex( $value = false )
        {
            $this->_itemIndex = intval( $value );
        }
        // }}} setActiveIndex( )

        // {{{ setDirection( )
        function setDirection( $value = false )
        {
            $this->_is_vertical = $value;
        }
        // }}} setDirection( )

        // {{{ _create( )
        function _create( )
        {
            $n = count( $this->_array );

            /**
             * nothing to create...
             */
            if ( $n < 1 )
                return null;

            $res = '<table class="main_table">' . EOL;

            if ( $this->_is_vertical === true ) {
                /**
                 * vertical menu
                 */
                $tr     = '<tr>' . EOL ;
                $tr_end = '</tr>' . EOL ;
                $end    = null;
            }
            else {
                /**
                 * horizontal menu
                 */
                $tr     = null;
                $tr_end = null;
                $res   .= '<tr>' . EOL ;
                $end    = '</tr>' . EOL ;
            } // if

            if ( $this->_itemIndex > $n ) {
                $this->_itemIndex = 0;
            } // if

            for ( $i = 0 ; $i < $n ; $i ++ ) {
                if ( $i == $this->_itemIndex ) {
                    $s = 'active';
                }
                else {
                    $s = 'simple';
                }
                $res .= $tr . '<td class="'. $s .'" onmouseover="this.className=\'td_on\'" onmouseout ="this.className=\''.$s.'\'">' .
                                 '<a class="a_'. $s .'" href="' . $this->_array[ $i ][ 'href' ] . '">' .
                                 $this->_array[ $i ][ 'caption' ] .
                              '</a></td>' . $tr_end . EOL;
            } // for
            $res .= $end . '</table>' . EOL;

            return $res;
        }
        // }}} _create( )

        // {{{ output( )
        function output( )
        {
            return $this->_create();
        }
        // }}} output( )
    }
    // }}}

?>